% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% Ph.D. Course "Intelligence for Embedded Systems"
% Prof. Manuel Roveri
% Politecnico di Milano, Italy
% Jan, 2015
% 
% ----- "Uncertainty, Information and Learning Mechanisms - Part 1"
% -> Example 3_2_A) Linear Dataset - Linear Model
% 
% Modify the number of points and the std of the noise
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


clear;
clc;
close all;
addpath('./functions');

%Number of points used for training
N = 100;
%Noise standard deviation
std_dev = 1.5;

%Training data generation
Xt = 4*rand(1,N)-2; %uniform samples on [-2;2]
noise = std_dev * randn(1,N);
Yt = lin_fun(Xt,noise);


%% Network training

% Initializing network
neural_net = linearlayer;

neural_net = configure(neural_net,Xt(:,1),Yt(:,1)); %these input are needed to specify the dimension of the inputs and outputs

% Training network
neural_net = train(neural_net,Xt,Yt);

%% Plotting results
plot_nn_regression(@lin_fun,neural_net,Xt,Yt);
