% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% Ph.D. Course "Intelligence for Embedded Systems"
% Prof. Manuel Roveri
% Politecnico di Milano, Italy
% Jan, 2015
% 
% ----- "Uncertainty, Information and Learning Mechanisms - Part 1"
% -> Example 3_2_A) Nonlinear Dataset - Nonlinear Model
%
% Modify the number of points, the number of hidden units and the std of the noise
%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear;
clc;
close all;
addpath('./functions');

%Hidden node number
n_hidden_nodes = 10;

%Number of points used for training
N = 50;
%Noise standard deviation
std_dev = 0.05;

%Training data generation
Xt = 4*rand(1,N)-2; %uniform samples on [-2;2]
noise = std_dev * randn(1,N);
Yt = nonlin_fun(Xt,noise);


%% Network training

% Initializing network
neural_net = fitnet(n_hidden_nodes);

%Training network
neural_net = train(neural_net,Xt,Yt);


%% Plotting results
plot_nn_regression(@nonlin_fun,neural_net,Xt,Yt);

%neural_net.divideParam
