% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% Ph.D. Course "Intelligence for Embedded Systems"
% Prof. Manuel Roveri
% Politecnico di Milano, Italy
% Jan, 2015
% 
% ----- "Uncertainty, Information and Learning Mechanisms - Part 1"
% -> Example 3_2_E) Classification - Sample Partitioning
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear;
clc;
close all;
addpath('./functions');

%Hidden node number
n_hidden_nodes = 20;

% Number of samples for training (the total number of samples is 150
N = 75;

%Importing iris dataset
[Xt Yt] = iris_dataset;

%% Network training

% Initializing network for classification

%%  SAMPLE PARTITIONING %%%
shaffled_index = randperm(length(Yt));

X_D = Xt (:,shaffled_index(1:N));
X_E = Xt (:,shaffled_index(N+1:end));

Y_D = Yt (:,shaffled_index(1:N));
Y_E = Yt (:,shaffled_index(N+1:end));

neural_net1 = patternnet(n_hidden_nodes);
neural_net1 = train(neural_net1,X_D,Y_D);
Y_output = neural_net1(X_E);

plotconfusion(Y_E,Y_output)



